<?php
include "common.inc.php";
# Open DB
$db = OpenDB();

include "common_header.php";
?>

<p align='justify'>
    <h3 class='title'>Introduzione</h3>
    <b>SquidTL</b> &egrave; un programma che permette di definire dei limiti basati sul numero di richieste HTTP effettuate su un certo sito web.
    Essendo il protocollo HTTP <i>stateless</i> &egrave; complicato riuscire a stabile con precisione il numero di visite ed il tempo che un utente 
    spende su un certo sito web, cos&igrave; sar&agrave; necessario un importante lavoro di tuning per stabilire con la massima precisione possibile 
    le soglie desiderate.
</p>
<p align='justify'>
    <h3 class='title'>Sintassi e funzionamento regole</h3>
    Le regole basate su domini e sugli utenti sfruttano le <a href='http://www.cs.utah.edu/dept/old/texinfo/regex/regex.html#SEC2'>GNU Regular Expressions</a> cos&igrave; 
    da permettere la massima flessibilit&agrave; nella definizione dei parametri.
</p>
<p align='justify'>
    Attualmente si possono definire regole basate sull'IP di provenienza, sull'Ident dell'utente (richiede l'autenticazione sul proxy Squid) e sul dominio di destinazione.
    In realt&agrave; &egrave; fondamentale che il proxy Squid venga configurato in modo da richiedere username e password all'utente, ad esempio in <i>squid.conf</i>:
    <blockquote>
	auth_param basic program /usr/local/squid/libexec/squid_ldap_auth -v 3 -b ...                                                                                                         
	auth_param basic children 5                                                                                                                                  
	auth_param basic realm Squid LDAP Auth                                                                                                                             
	auth_param basic credentialsttl 1 minute                                                                                                                     
	
	acl ldap-auth proxy_auth REQUIRED
	http_access deny !ldap-auth
	http_access allow ldap-auth
    </blockquote>
    mentre <b>SquidTL</b> deve essere configurato come URL Rewriter (in <i>squid.conf</i>):
    <blockquote>
	url_rewrite_program /usr/local/squid/libexec/squidtl --verbose
    </blockquote>
    L'opzione <i>--verbose</i> permette di avere un log dettagliato delle operazioni eseguite da SquidTL.
    L'autenticazione dell'utente &egrave; importante per alcuni motivi fondamentali:
    <ul>
	<li>I limiti sono definiti sulle visite effettuate dall'utente e non dal PC al quale si collega (nel caso di aule aperte al pubblico)</li>
	<li>Gli IP possono essere assegnati da un server DHCP che ne potrebbe cambiare l'indirizzo ad ogni richiesta</li>
    </ul>
</p>    
<p align='justify'>
    <h3 class='title'>Requisiti</h3>
    SquidTL richiede MySQL, sia per la compilazione dell'eseguibile che per l'uso. Le tabelle necessarie sono definite nel file <i>squidtl.sql</i> ed &egrave; importante assicurarsi
    del corretto funzionamento dell'accesso al DB: SquidTL utilizza alcune funzioni di MySQL per calcolare i tempi di utilizzo, oltre a memorizzare i dati delle visite.
    Per la compilazione &egrave; avere il pacchetto GNU make, gcc ed autoconf, oltre alle librerie di MySQL. Per l'uso della GUI e della pagina di notifica blocco &egrave; necessario 
    avere un server HTTP (es. Apache) con supporto PHP.
</p>
<p align='justify'>
    <h3 class='title'>Flusso</h3>
    Le richieste HTTP provenienti dalla INTRANET e dirette al Proxy Squid (usualmente porta 8080) vengono controllate secondo le ACL di Squid e, se permesse, viene inviato a SquidTL 
    l'URL desiderato insieme ad altri parametri:
    <blockquote>
	http://www.repubblica.it/2009/11/sezioni/cronaca/aereo-pisa/aereo-pisa/este_59727_01290.jpg 127.0.0.1/localhost pinassi2 GET myip=127.0.0.1 myport=3128
    </blockquote>
    SquidTL aggiunge la richiesta sulla tabella DB_Access ed esegue una serie di query per analizzare e decidere se l'URL deve essere bloccato (rediretto) oppure no.
    <img src='/img/squidtl-flow.jpg' align='left'>
    Nel caso l'URL debba essere bloccato, la <i>violazione</i> viene memorizzata nella tabella DB_Events.
    <br>
    Il server MySQL pu&ograve; anche risiedere su una macchina esterna a quella dove risiede il proxy. Tuttavia, prima di optare per una topologia <i>double-tier</i> &egrave; opportuno
    verificare un eventuale degrado di prestazioni del sistema.
    <br>
    SquidTL &egrave; stato scritto in linguaggio C proprio per massimizzare la velocit&agrave; di esecuzione del programma, minimizzando il memory footprint ed il carico CPU.
    <br clear=all>
</p>
<p align='justify'>
    <h3 class='title'>Licenza d'uso</h3>
    SquidTL &egrave; rilasciato sotto licenza GNU GPLv2 che ne permette la distribuzione sotto forma di codice sorgente e la modifica da parte dell'utente, purch&egrave; le eventuali modifiche siano
    rilasciate sotto medesima licenza.
    <br><br>
</p>

<?php
include "common_footer.php";
?>